


 25-akpm/arch/x86_64/kernel/time.c |   16 ++++++++++------
 1 files changed, 10 insertions(+), 6 deletions(-)

diff -puN arch/x86_64/kernel/time.c~x86_64-do_settimeofday-update arch/x86_64/kernel/time.c
--- 25/arch/x86_64/kernel/time.c~x86_64-do_settimeofday-update	Wed Jun 11 14:59:43 2003
+++ 25-akpm/arch/x86_64/kernel/time.c	Wed Jun 11 15:01:53 2003
@@ -102,20 +102,23 @@ void do_gettimeofday(struct timeval *tv)
  * ages already.
  */
 
-void do_settimeofday(struct timeval *tv)
+int do_settimeofday(struct timespec *tv)
 {
+	if ((unsigned long)tv->tv_nsec >= NSEC_PER_SEC)
+		return -EINVAL;
+
 	write_seqlock_irq(&xtime_lock);
 
-	tv->tv_usec -= do_gettimeoffset() +
-		(jiffies - wall_jiffies) * tick_usec;
+	tv->tv_nsec -= do_gettimeoffset() +
+		(jiffies - wall_jiffies) * tick_usec * 1000;
 
-	while (tv->tv_usec < 0) {
-		tv->tv_usec += 1000000;
+	while (tv->tv_nsec < 0) {
+		tv->tv_nsec += NSEC_PER_SEC;
 		tv->tv_sec--;
 	}
 
 	xtime.tv_sec = tv->tv_sec;
-	xtime.tv_nsec = (tv->tv_usec * 1000);
+	xtime.tv_nsec = tv->tv_nsec;
 
 	time_adjust = 0;		/* stop active adjtime() */
 	time_status |= STA_UNSYNC;
@@ -124,6 +127,7 @@ void do_settimeofday(struct timeval *tv)
 
 	write_sequnlock_irq(&xtime_lock);
 	clock_was_set();
+	return 0;
 }
 
 /*

_
